import processing.core.*; 
import processing.xml.*; 

import simpleML.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Midterm5 extends PApplet {



// Modeling exchange rates
// Zoe Fraade-Blanar (http://www.binaryspark.com)

// Demonstrates attractive force one body exerts on a group of bodies stored in an array
// G ---> universal gravitational constant
// m1 --> mass of object #1
// m2 --> mass of object #2
// d ---> distance between objects
// F = (G*m1*m2)/(d*d)


//to do.  Read in XML.  make objects equal to how many
//make size of object equal to inverse strength of each
//make objects rotate
//make dollar rotate
//color objects?
//make objects equal to symbols?
//Make each object actually be an array of objects


int MAX = 64;  //that's how many currencies are on the list.  Would be good if we had a way to make it dynamic
Currency[] t = new Currency[MAX];  //create the array of 5 things (which are not yet substantiated)
Dollar a;
boolean showVectors = true;

XMLRequest xmlRequest;  //getting the information to initialize particles...with
boolean bodiesReady = false;  //we don't want to do any operations on bodies before they're ready!

PFont font;
PFont cFont;

boolean showName;
boolean showCrosshairs;
boolean showMoney;
boolean showSparkles;


public void setup() {
  size(800,500);
  
  background(255);
  smooth();
  
  showName = false;
  showCrosshairs = false;
  showMoney = true;
 showSparkles = false;

  // Currency
  /*--
  for (int i = 0; i < t.length; i++) {
    PVector ac = new PVector(0.0,0.0);                      //to start, each has o acc on thier x and y
    PVector ve = new PVector(random(-1,1),random(-1,1));    //but they start at a random constant velocity
    PVector lo = new PVector(random(width),random(height)); //at a random location
    t[i] = new Currency(ac,ve,lo,random(8,16));                //with a rando mass!
  }
  */
  
  //  Dollar
  a = new Dollar(new PVector(width/2,height/2),20,4);  //a new attractor object with a pvector location, 20 mass, and .4 gravity.  

  xmlRequest = new XMLRequest(this, "http://www.binaryspark.com/Academia/Nature/Midterm/financialGrab.php" );  //make the XML request
  xmlRequest.makeRequest();
  
  font = loadFont("FrenchScriptMT-48.vlw"); 
  cFont = loadFont("BitstreamVeraSans-Roman-10.vlw");

}

public void draw() {
  fill (255, 1);
  rect (0,0, width, height);
  
  if (bodiesReady == true){  //We only want to do operations on bodies if they exist!
  
      a.rollover(mouseX,mouseY);
      a.go();

      for (int i = 0; i < t.length; i++) {
        // Calculate a force exerted by "Dollar" on "Currency"
        PVector f = a.calcGravForce(t[i]);
        // Apply that force to the thing
        t[i].applyForce(f);
        // Update and render
        t[i].go();
      }//end for
  }//end if
  
  else {
    fill(95, 224, 57); 
    textFont(font, 48); 
    text("Loading Financial Data", 15, 50); 
  }

}//end draw

public void mousePressed() {
  a.clicked(mouseX,mouseY);
}

public void mouseReleased() {
  a.stopDragging();
}

public void keyPressed() {
  
  if (bodiesReady == true) {  //Only show em if you've got em!
    
    
    if (key == 'm') {
       
       showMoney = true;
     }
    
    if (key == 'v')  {
    showVectors = !showVectors;
    }//end if v
    
    if (key == 'n') {//only if we have bodies, toggle the ability to see names
      showName = !showName;
       }//end if n
      
     if (key == 'c') {
       showCrosshairs = !showCrosshairs;
       showSparkles = false;  //so we never have sparkles and crosshairs at the same time
       showMoney = false;  //to make sure we never have the two showing at the same time
  
       
 
    }//end if c
     
     if (key == 's') {
       
       showSparkles = !showSparkles;
       showCrosshairs = false;
       showMoney = false;
     }
    
    //finally, make sure that something's always showing
    
    if((showSparkles == false) && (showCrosshairs == false)){
      
      showMoney = true;
    }
    
    if (showMoney == true) {  
      
     showSparkles = false;  //to make sure we never have the two showing at the same time
     showCrosshairs = false;
      
    }
    
    
  }//end if bodies ready
  
  
}

// Renders a vector object 'v' as an arrow and a location 'loc'
public void drawVector(PVector v, PVector loc, float scayl) {
  if (v.mag() > 0.0f) {
    pushMatrix();
    float arrowsize = 4;
    // Translate to location to render vector
    translate(loc.x,loc.y);
    stroke(0);
    // Call vector heading function to get direction (note that pointing up is a heading of 0) and rotate
    rotate(v.heading2D());
    // Calculate length of vector & scale it to be bigger or smaller if necessary
    float len = v.mag()*scayl;
    // Draw three lines to make an arrow (draw pointing up since we've rotate to the proper direction)
    line(0,0,len,0);
    line(len,0,len-arrowsize,+arrowsize/2);
    line(len,0,len-arrowsize,-arrowsize/2);
    popMatrix();
  }
}

public void netEvent(XMLRequest ml) {
  
  // Retrieving an array of all XML elements inside"  title*  "tags
  String[] codes = ml.getElementArray( "code" );
  String[] rates = ml.getElementArray( "rate" );
  //for (int i = 0; i < codes.length; i++ ) {  //for testing purposes only
    //println(codes[i]);
    //println(rates[i]);
  //}
  
  for (int i = 0; i < t.length; i++) {                      //Now, let's make some bodies!
    PVector ac = new PVector(0.0f,0.0f);                      //to start, each has o acc on thier x and y
    PVector ve = new PVector(random(-1,1),random(-1,1));    //but they start at a random constant velocity
    PVector lo = new PVector(random(width/2+width/4),random(height/2+height/4)); //at a random location
    //PVector lo = new PVector(0,0); //at a random location
    
    float currentRate = PApplet.parseFloat(rates[i]); //get the rate for this article of currency
    float mass = constrain(40/currentRate, 1, 50);  // invert so the less something is worth, the smaller it is, make sure it's never oto small or too big
    
    mass=map (mass, 1, 50, 40, 100);  //so we get an even range
    
    String name = codes[i];
    t[i] = new Currency(ac,ve,lo,mass, name);               
  }
    fill (255);  //wipe the screen blank to start  why isn't this working?
    //rect (0,0, width, height);
   // background(255);
  
  bodiesReady = true;  //we've got bodies, so we're ready to do something with them
   


}


// Attraction
// Daniel Shiffman <http://www.shiffman.net>

// A class to describe a currency in our world, has vectors for location, velocity, and acceleration
// Also includes scalar values for mass, maximum velocity, and elasticity

class Currency {
  PVector loc;
  PVector vel;
  PVector acc;
  float mass;
  float max_vel;
  float bounce = 1.0f; // How "elastic" is the object
  String name;
  
  PImage bill;
  int c;

    
  Currency(PVector a, PVector v, PVector l, float m_, String n ) {
    acc = a.get();
    vel = v.get();
    loc = l.get();
    mass = m_;
    name = n;
    max_vel = 16.0f;
  
    //println(name + ".jpg");
   
    bill = loadImage(name + ".jpg");  //load the image
    
    c = bill.get(50, 25);  //get the color exactly in the middle of the image
    
    bill.resize(PApplet.parseInt(mass), 0);  //resize according to mass

   
  }
  
  public PVector getLoc() {
    return loc;
  }

  public PVector getVel() {
    return vel;
  }
  public float getMass() {
    return mass;
  }

  public void applyForce(PVector force) {
    force.div(mass);
    acc.add(force);
    if (!showVectors) {
      drawVector(force,loc,1000);
    }    
  }

  // Main method to operate object
  public void go() {
    update();
    render();
  }
  
  // Method to update location
  public void update() {
    vel.add(acc);
    vel.limit(max_vel);
    loc.add(vel);
    // Multiplying by 0 sets the all the components to 0
    acc.mult(0);
  }
  
  // Method to display
  public void render() {
    ellipseMode(CENTER);
    stroke(255);
    fill(255,100);
    //ellipse(loc.x,loc.y,mass*2,mass*2);
    if (!showVectors) {
      drawVector(vel,loc,20);
    }
   
   if (showCrosshairs == true) {
     
     //showSparkles = false;  //to make sure we never have the two showing at the same time
     //showMoney = false;
     
     stroke(c, 255);  //draw the crosshairs
     line(loc.x, 0, loc.x, height);
     line(0, loc.y, width, loc.y);
     
     //line(loc.x, width, loc.y, height);
     //line(loc.y, 0, loc.x, height);
     
     //line(0,0, loc.x, loc.y);
     //line(width, 0, loc.x, loc.y);
     //line (0, height, loc.x, loc.y);
     //line (width, height, loc.x, loc.y);
     
     
   }//end if
   
   if (showSparkles == true) {
     
     //showCrosshairs = false;  //to make sure we never have the two showing at the same time
     //showMoney = false;
     
     pushMatrix();    //rotate it
    
      translate(loc.x,loc.y);
      rotate(vel.heading2D());
    
     stroke(c, 255);  //draw the crosshairs
     line(0, -200, 0, 200);
     line(200, 0, -200, 0);
     
    
    popMatrix();
     
   }//end if
   
   if (showMoney == true)   {
     
      //showSparkles = false;  //to make sure we never have the two showing at the same time
     //showCrosshairs = false;
     
     pushMatrix();    //rotate it
    
    translate(loc.x,loc.y);
    rotate(vel.heading2D());
    imageMode(CENTER);
    image(bill, 0, 0);
    
    popMatrix();
    
   }//end else
    
    if (showName == true) {
    
    fill(0); //display the name of the item
    textFont(cFont, 10); 
    text(name, loc.x,loc.y);
    }
   
  }
}

// Attraction
// Daniel Shiffman <http://www.shiffman.net>

// A class for a draggable attractive body in our world

class Dollar {
  float mass;    // Mass, tied to size
  float G;       // Gravitational Constant
  PVector loc;   // Location
  boolean dragging = false; // Is the object being dragged?
  boolean rollover = false; // Is the mouse over the ellipse?
  PVector drag;  // holds the offset for when object is clicked on
  
   // Doing oscillation with velocity
  float xtheta;
  float xtheta_vel;

  // Having two separate variables for x,y is not so great
  // This could be improved by using our Vector3D class!
  float ytheta;
  float ytheta_vel;

  Dollar(PVector l_,float m_, float g_) {
    loc = l_.get();
    mass = m_;
    G = g_;
    drag = new PVector(0.0f,0.0f);
    
    xtheta = ytheta = 0.0f;
    xtheta_vel = 0.005f;
    ytheta_vel = 0.007f;
  }

  public void go() {
    move();
    render();
    drag();
  }

  public PVector calcGravForce(Currency t) {
    PVector dir = PVector.sub(loc,t.getLoc());        // Calculate direction of force
    float d = dir.mag();                              // Distance between objects
    d = constrain(d,5.0f,25.0f);                        // Limiting the distance to eliminate "extreme" results for very close or very far objects
    dir.normalize();                                  // Normalize vector (distance doesn't matter here, we just want this vector for direction)
    float force = (G * mass * t.getMass()) / (d * d); // Calculate gravitional force magnitude
    dir.mult(force);                                  // Get force vector --> magnitude * direction
    return dir;
   
  }

  public void move() {  //method to occelate the Dollar in time to inflation
    
    float amplitude = width/2-100;
    loc.x = amplitude * sin(xtheta);
    loc.x=width/2-loc.x;
    xtheta += xtheta_vel;
    

    amplitude = height/2-100;
    loc.y = amplitude * cos(ytheta);
    loc.y=height/2-loc.y;
    ytheta += ytheta_vel;  
  
  }

  // Method to display
  public void render() {
    ellipseMode(CENTER);
    stroke(0);
    if (dragging) fill (50);
    else if (rollover) fill(100);
    else fill(175,200);
    //ellipse(loc.x,loc.y,mass*2,mass*2);
  }

  // The methods below are for mouse interaction
  public void clicked(int mx, int my) {
    float d = dist(mx,my,loc.x,loc.y);
    if (d < mass) {
      dragging = true;
      drag.x = loc.x-mx;
      drag.y = loc.y-my;
    }
  }

  public void rollover(int mx, int my) {
    float d = dist(mx,my,loc.x,loc.y);
    if (d < mass) {
      rollover = true;
    } else {
      rollover = false;
    }
  }

  public void stopDragging() {
    dragging = false;
  }
  
 

  public void drag() {
    if (dragging) {
      loc.x = mouseX + drag.x;
      loc.y = mouseY + drag.y;
    }
  }

}


  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#e0dfe3", "Midterm5" });
  }
}
